/**************************************************************************/
// Copyright (c) 1998-2007 Autodesk, Inc.
// All rights reserved.
// 
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information written by Autodesk, Inc., and are
// protected by Federal copyright law. They may not be disclosed to third
// parties or copied or duplicated in any form, in whole or in part, without
// the prior written consent of Autodesk, Inc.
//**************************************************************************/
// DESCRIPTION: Appwizard generated plugin
// AUTHOR: 
//***************************************************************************/

#include "ExporterOption.h"

//////////////////////////////////////////////////////////////////////////
// ADNDemoExportOpts functions

ExporterOption::ExporterOption()
{
	m_bExportObject = m_bExportAnimation = m_bExportMaterial = m_bExportTexture = true;
	m_bForceSample = false;
}

ExporterOption::~ExporterOption()
{
	// cleanup
}

bool ExporterOption::ShowDialog()
{
	// Pop a modal dialog.  If we return 0,
	// the user hit cancel
	return 0 != DialogBoxParam(hInstance, 
					MAKEINTRESOURCE(IDD_OPTION), 
					GetActiveWindow(), 
					DialogProc, (LPARAM)this); 
}

//////////////////////////////////////////////////////////////////////////
// Dialog Proc

INT_PTR CALLBACK ExporterOption::DialogProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam) {
	static ExporterOption *imp = NULL;

	switch(message) {
		case WM_INITDIALOG:
			imp = (ExporterOption *)lParam;
			CenterWindow(hWnd,GetParent(hWnd));

			SetCheckBox(hWnd, IDC_CHECK_OBJECT, imp->ExportObject());
			SetCheckBox(hWnd, IDC_CHECK_ANIMATION, imp->ExportAnimation());
			SetCheckBox(hWnd, IDC_CHECK_FORCE_SAMPLE, imp->ForceSample());
			SetCheckBox(hWnd, IDC_CHECK_EXPORT_MATERIAL, imp->ExportMaterial());
			SetCheckBox(hWnd, IDC_CHECK_EXPORT_TEXTURE, imp->ExportTexture());
			return TRUE;

		case WM_COMMAND:
			switch(wParam)
			{
			case IDC_OK:
				imp->m_bExportObject = IsDlgButtonChecked(hWnd, IDC_CHECK_OBJECT) == BST_CHECKED;
				imp->m_bExportAnimation = IsDlgButtonChecked(hWnd, IDC_CHECK_ANIMATION) == BST_CHECKED;
				imp->m_bForceSample = IsDlgButtonChecked(hWnd, IDC_CHECK_FORCE_SAMPLE) == BST_CHECKED;
				imp->m_bExportMaterial = IsDlgButtonChecked(hWnd, IDC_CHECK_EXPORT_MATERIAL) == BST_CHECKED;
				imp->m_bExportTexture = IsDlgButtonChecked(hWnd, IDC_CHECK_EXPORT_TEXTURE) == BST_CHECKED;
				EndDialog(hWnd, IDOK);

			case IDC_CANCEL:
				EndDialog(hWnd, IDCANCEL);
				return 1;
			}
			return TRUE;

		case WM_CLOSE:
			EndDialog(hWnd, 0);
			return 1;
	}
	return 0;
}