/**********************************************************************
 *<
	FILE: maxPluginTest.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 2003, All Rights Reserved.
 **********************************************************************/

#include "maxPluginTest.h"
#include "ExporterOption.h"
#include <stdmat.h>
#include <decomp.h>

#define maxPluginTest_CLASS_ID	Class_ID(0x9adaf698, 0xcbe0889e)

class maxPluginTest : public SceneExport 
{
	public:
		
		static HWND hParams;
		
		int				ExtCount();					// Number of extensions supported
		const TCHAR *	Ext(int n);					// Extension #n (i.e. "3DS")
		const TCHAR *	LongDesc();					// Long ASCII description (i.e. "Autodesk 3D Studio File")
		const TCHAR *	ShortDesc();				// Short ASCII description (i.e. "3D Studio")
		const TCHAR *	AuthorName();				// ASCII Author name
		const TCHAR *	CopyrightMessage();			// ASCII Copyright message
		const TCHAR *	OtherMessage1();			// Other message #1
		const TCHAR *	OtherMessage2();			// Other message #2
		unsigned int	Version();					// Version number * 100 (i.e. v3.01 = 301)
		void			ShowAbout(HWND hWnd);		// Show DLL's "About..." box

		BOOL SupportsOptions(int ext, DWORD options);
		int				DoExport(const TCHAR *name,ExpInterface *ei,Interface *i, BOOL suppressPrompts=FALSE, DWORD options=0);

		//Constructor/Destructor
		maxPluginTest();
		~maxPluginTest();		

	private:
		//Our options
		ExporterOption m_option;
		FILE* m_pFile;

	private:
		void Export(INode* pNode, int iTreeDepth = 0);
		void ExportObject(INode* pNode, int iTreeDepth);
		void ExportObject(TriObject* pTriObj, int iTreeDepth);
		void ExportMaterial(INode* pNode, int iTreeDepth);
		void ExportTexture(Mtl* pMtl, int iTreeDepth);
		void ExportTRS(INode* pNode, int iTreeDepth, TimeValue t = 0);
		void ExportAnimation(INode* pNode, int iTreeDepth);

		// Export the given texture map.  If the texture is 
		// a bitmap, export its path and UV parameters
		void WriteTexture(Texmap* pTex, const char* pSlotName, int iTreeDepth);

		// Sample the nodes TRS over the scene time
		void ExportAnimationSample(INode* pNode, int iTreeDepth);

		// Export the key frames for the given controller (pAnim).
		// If this animatable doesnt support keys, try it's subanims
		void ExportAnimationKeys(Animatable* pAnim, const char* pCtrlName, int iTreeDepth);

		template <class KeyType>
		void ExportAnimationKeyLinear(IKeyControl* iKeyControl, int iTreeDepth);
		template <class KeyType>
		void ExportAnimationKeyBezier(IKeyControl* iKeyControl, int iTreeDepth);
		template <class KeyType>
		void ExportAnimationKeyTCB(IKeyControl* iKeyControl, int iTreeDepth);


		bool BeginWriting(const char* pPath);
		void EndWriting();
		void Write(int indent, const char* pMsg, ...);
		void Write(int indent, const Matrix3& tmVal);

		// write out the given value after the message
		void WriteValue(int indent, const char* pMsg, float val);
		void WriteValue(int indent, const char* pMsg, const Point3& val);
		void WriteValue(int indent, const char* pMsg, const Quat& val);
		void WriteValue(int indent, const char* pMsg, const AngAxis& val);
		void WriteValue(int indent, const char* pMsg, const ScaleValue& val);
};



class maxPluginTestClassDesc : public ClassDesc2 {
	public:
	int 			IsPublic() { return TRUE; }
	void *			Create(BOOL loading = FALSE) { return new maxPluginTest(); }
	const TCHAR *	ClassName() { return GetString(IDS_CLASS_NAME); }
	SClass_ID		SuperClassID() { return SCENE_EXPORT_CLASS_ID; }
	Class_ID		ClassID() { return maxPluginTest_CLASS_ID; }
	const TCHAR* 	Category() { return GetString(IDS_CATEGORY); }

	const TCHAR*	InternalName() { return _T("maxPluginTest"); }	// returns fixed parsable name (scripter-visible name)
	HINSTANCE		HInstance() { return hInstance; }					// returns owning module handle
	

};

static maxPluginTestClassDesc maxPluginTestDesc;
ClassDesc2* GetmaxPluginTestDesc() { return &maxPluginTestDesc; }


//--- maxPluginTest -------------------------------------------------------
maxPluginTest::maxPluginTest()
{
	m_pFile = NULL; 
}

maxPluginTest::~maxPluginTest() 
{
	DbgAssert(m_pFile == NULL);
}

int maxPluginTest::ExtCount()
{
	//TODO: Returns the number of file name extensions supported by the plug-in.
	return 1;
}

const TCHAR *maxPluginTest::Ext(int n)
{		
	//TODO: Return the 'i-th' file name extension (i.e. "3DS").
	return _T("txt");
}

const TCHAR *maxPluginTest::LongDesc()
{
	//TODO: Return long ASCII description (i.e. "Targa 2.0 Image File")
	return _T("MaxPlugin Test");
}
	
const TCHAR *maxPluginTest::ShortDesc() 
{			
	//TODO: Return short ASCII description (i.e. "Targa")
	return _T("My ASCII");
}

const TCHAR *maxPluginTest::AuthorName()
{			
	//TODO: Return ASCII Author name
	return _T("dolphin");
}

const TCHAR *maxPluginTest::CopyrightMessage() 
{	
	// Return ASCII Copyright message
	return _T("Free");
}

const TCHAR *maxPluginTest::OtherMessage1() 
{		
	//TODO: Return Other message #1 if any
	return _T("");
}

const TCHAR *maxPluginTest::OtherMessage2() 
{		
	//TODO: Return other message #2 in any
	return _T("");
}

unsigned int maxPluginTest::Version()
{				
	//TODO: Return Version number * 100 (i.e. v3.01 = 301)
	return 100;
}

void maxPluginTest::ShowAbout(HWND hWnd)
{			
	// Optional
}

BOOL maxPluginTest::SupportsOptions(int ext, DWORD options)
{
	// TODO Decide which options to support.  Simply return
	// true for each option supported by each Extension 
	// the exporter supports.

	return TRUE;
}


int	maxPluginTest::DoExport(const TCHAR *name,ExpInterface *ei,Interface *i, BOOL suppressPrompts, DWORD options)
{
	//TODO: Implement the actual file Export here and 
	//		return TRUE If the file is exported properly

	// /Show our UI.  Allow user to cancel
	if (!suppressPrompts && !m_option.ShowDialog())
	{
		// User cancelled, return TRUE
		// Otherwise Max displays export failed dialog
		return TRUE;
	}

	if (BeginWriting(name))
	{
		// Interface* can also be accessed by GetCOREInterface()
		INode* pRootNode = i->GetRootNode();

		//Export tree.
		Export(pRootNode);

		EndWriting();

		return TRUE; // We have successfully exported to our file!
	}

	// If we are here, something in the export failed.
	return FALSE;
}


void maxPluginTest::Export(INode* pNode, int iTreeDepth /* = 0 */)
{
	// First step to export: What are we exporting?
	// Here we are going to export the basic scene tree,
	// identifying each node by name.

	MCHAR* pNodeName = pNode->GetName();
	int nChildren = pNode->NumberOfChildren();

	// Write out this node as [NodeName] : XX Children
	Write(iTreeDepth, "[%s] : %i children", pNodeName, nChildren);

    // Write out this nodes local transform
	ExportTRS(pNode, iTreeDepth);

	// Write out the animation (if it this node has any)
	if(m_option.ExportAnimation()) 
		ExportAnimation(pNode, iTreeDepth);

	// Write out the color information for this node.
	if (m_option.ExportMaterial()) 
		ExportMaterial(pNode, iTreeDepth);

	// Write out this nodes object properties`
	if(m_option.ExportObject())
		ExportObject(pNode, iTreeDepth);

	// Recursively call the children
	iTreeDepth++;
	for (int i = 0; i < nChildren; i++)
	{
		Export(pNode->GetChildNode(i), iTreeDepth);
	}
}

void maxPluginTest::ExportObject(INode* pNode, int iTreeDepth)
{
	// Get a pointer to this nodes object reference
	Object* pObject = pNode->GetObjectRef();

	// the root node for example, doesnt have an object
	if (pObject != NULL)
	{
		SClass_ID lSuperID = pObject->SuperClassID();
		Class_ID lClassID = pObject->ClassID();

		// Write out our class types
		// See also SDK documentation for "list of Super Class IDs"
		Write(iTreeDepth, "Obj SuperclassID : %X", lSuperID);
		Write(iTreeDepth, "Obj ClassID : (%X, %X)", lClassID.PartA(), lClassID.PartB());

		// Is it possible that we can convert this object to
		// something we understand?  Here we try converting
		// to a TriObject, using its Class_ID
		if (pObject->CanConvertToType(triObjectClassID))
		{
			TriObject* pTriObject = (TriObject*)pObject->ConvertToType(0, triObjectClassID);
			if (pTriObject != NULL)
			{
				// Write out the mesh indented
				ExportObject(pTriObject, iTreeDepth + 1);

				// Note that if the TriObject pointer does not
				// point to the the original object, it is a new
				// instance that we are now responsible for
				if (pTriObject != pObject)
				{
					// Never call delete directly on any max class
					pTriObject->DeleteMe();
				}
			}
		}
	}
}

void maxPluginTest::ExportObject(TriObject* pTriObj, int iTreeDepth)
{
	// See the SDK Documentation for "PG: Working With Meshes"

	// Get the data container
	Mesh& lMesh = pTriObj->GetMesh();

	// How many vertices?
	int nVerts = lMesh.getNumVerts();
	Write(iTreeDepth, "Number of Vertices: %i", nVerts);

	// Write the vertices positions
	for (int i = 0; i < nVerts; i++)
	{
		Point3& vtx = lMesh.getVert(i);
		Write(iTreeDepth, "Vertex[%02i] : (%f,\t%f,\t%f)", i, vtx.x, vtx.y, vtx.z);
	}

	// Write out our triangle indices
	int nTris = lMesh.getNumFaces();
	Write(iTreeDepth, "Number of Triangles : %i", nTris);

	for (int i = 0; i < nTris; i++)
	{
		// Mesh has a public property, lFace,
		// that we use to access face data
		Face& lFace = lMesh.faces[i];
		// Retrieves a pointer to the index array
		DWORD* pIndices = lFace.getAllVerts();

		Write(iTreeDepth, "Face[%02i], Vertex IDs : (%u, %u, %u)",
					i, pIndices[0], pIndices[1], pIndices[2]);
	}
}

void maxPluginTest::ExportMaterial(INode* pNode, int iTreeDepth)
{
	// The node stores the material for the object
	Mtl* pMtl = pNode->GetMtl();
	if (pMtl == NULL)
	{
		// This case is perfectly valid.  For simple scenes,
		// a node can specify a color for an object without
		// using the overhead of an entire material
		DWORD dwNodeColor = pNode->GetWireColor();
		Write(iTreeDepth, "Object Color: 0x%X", dwNodeColor);
	}
	else
	{
		// We have a material.  Lets export the basic parameters
		const MSTR& sMtlName = pMtl->GetName();
		Write(iTreeDepth, "Object Material: %s", sMtlName.data());
		WriteValue(iTreeDepth, "   Ambient: ", pMtl->GetAmbient());
		WriteValue(iTreeDepth, "   Diffuse: ", pMtl->GetDiffuse());
		WriteValue(iTreeDepth, "   Specular: ", pMtl->GetSpecular());
		WriteValue(iTreeDepth, "   Shininess: ", pMtl->GetShininess());
		WriteValue(iTreeDepth, "   Shininess Strength: ", pMtl->GetShinStr());

		if (pMtl->GetSelfIllumColorOn())
			WriteValue(iTreeDepth, "   Self Illumination: ", pMtl->GetSelfIllumColor());
		else 
			WriteValue(iTreeDepth, "   Self Illumination: ", pMtl->GetSelfIllum());

		// We have written out the very basic properties for a material.
		// However, there are some more properties missing from this implementation
		// that we could use.  Here we test to see if we have the standard material
		// and export some of its more 'advanced' properties
		if (pMtl->IsSubClassOf(Class_ID(DMTL_CLASS_ID, 0)))
		{
			StdMat* pStdMtl = (StdMat*)pMtl;
			WriteValue(iTreeDepth, "   Opacity: ", pStdMtl->GetOpacity(0));
			WriteValue(iTreeDepth, "   Opacity Falloff: ", pStdMtl->GetOpacFalloff(0));
		}

		// Export this materials textures
		if (m_option.ExportTexture()) 
			ExportTexture(pMtl, iTreeDepth);
	}
}

void maxPluginTest::ExportTexture(Mtl* pMtl, int iTreeDepth)
{
	// Iterate all the textures this mtl could possibly
	// have assigned.  If a texture is assigned, export it
	for (int i = 0; i < pMtl->NumSubTexmaps(); i++)
	{
		Texmap* pTex = pMtl->GetSubTexmap(i);
		if (pTex != NULL)
		{
			MSTR sSlotName = pMtl->GetSubTexmapSlotName(i);
			WriteTexture(pTex, sSlotName.data(), iTreeDepth + 1);
		}
	}
}

void maxPluginTest::WriteTexture(Texmap* pTex, const char* pSlotName, int iTreeDepth)
{
	// There are many different types of textures in Max
	// Which one have we got here?
	MSTR sTexClass;
	pTex->GetClassName(sTexClass);
	Write(iTreeDepth, "%s Tex: %s", pSlotName, sTexClass.data());

	// If our texture is an image file, write out its path
	if (pTex->ClassID() == Class_ID(BMTEX_CLASS_ID, 0))
	{
		BitmapTex* pBmpTex = (BitmapTex*) pTex;
		StdUVGen* pUVGen = pBmpTex->GetUVGen();

		// Note to reader: All these parameters could
		// be animated!  Here we only export at time
		// 0 for convenience, in production we must be careful
		// to take care of exporting values at the correct time
		float fUTile = pUVGen->GetUScl(0);
		float fVTile = pUVGen->GetVScl(0);

		Write(iTreeDepth, "   path: \"%s\"", pBmpTex->GetMapName());
		Write(iTreeDepth, "   U Tile = %.1f, V Tile = %.1f\n", fUTile, fVTile);
	}
}

void maxPluginTest::ExportTRS(INode* pNode, int iTreeDepth, TimeValue t /*=0*/)
{
	// Export the nodes TRS at time t (0 by default)
	Matrix3 tmWorld = pNode->GetNodeTM(t);
	Matrix3 tmParent = pNode->GetParentTM(t);
	Matrix3 tmLocal = tmWorld * Inverse(tmParent);

	Write(iTreeDepth, tmLocal);
}

void maxPluginTest::ExportAnimation(INode* pNode, int iTreeDepth)
{
	// How do we know this node is animated?
	// One way to tell is using validity intervals.
	// If the transform is valid forever, it never changes.
	Interval ivNodeValid = FOREVER;
	pNode->GetNodeTM(0, &ivNodeValid);
	if (ivNodeValid == FOREVER) return;

	// Has the user specified to sample
	// all animations?
	bool bSample = m_option.ForceSample();

	// Get the controller off the node.  If it is a TRS
	// see if we can export its keyframes
	Control* pNodeCtrl = pNode->GetTMController();
	Control* pSubCtrls[3];
	pSubCtrls[0] = pNodeCtrl->GetPositionController();
	pSubCtrls[1] = pNodeCtrl->GetRotationController();
	pSubCtrls[2] = pNodeCtrl->GetScaleController();

	// We should always prefer to export keyframes,
	// as it takes less space
	if (bSample != true)
	{
		for (int i = 0; i < 3; i++)
		{
			Control* pCtrl = pSubCtrls[i];

			// This is possible if we are not TRS
			// (eg, an IK Matrix3 controller)
			if (pCtrl != NULL)
			{
				// We always export keyframes if possible
				if (pCtrl->IsKeyable()) continue;

				if (pCtrl->GetXController() != NULL &&
					pCtrl->GetYController() != NULL &&
					pCtrl->GetZController() != NULL)
				{
					// This control has XYZ dimensions -
					// we understand this, we can export the
					// subanim keyframes instead of the keyframes
					// directly on the controller.  If we didnt
					// have these dimensions, we couldnt assume
					// how the sub-anims are used.
					continue;
				}
			}

			// If we are here, we dont understand how one of the
			// TRS controllers derive its value.  In this case, we
			// have to sample the TRS to be sure we are correct
			bSample = true;
			break;
		}
	}

	if (bSample)
	{
		ExportAnimationSample(pNode, iTreeDepth);
	}
	else
	{
		Write(iTreeDepth, "TRS Export: ");
		ExportAnimationKeys(pSubCtrls[0], "Position", iTreeDepth + 1);
		ExportAnimationKeys(pSubCtrls[1], "Rotation", iTreeDepth + 1);
		ExportAnimationKeys(pSubCtrls[2], "Scale", iTreeDepth + 1);
	}
}

void maxPluginTest::ExportAnimationSample(INode* pNode, int iTreeDepth)
{
	// Get the time range of the scene in max
	Interval ivAnimRange = GetCOREInterface()->GetAnimRange();

	// 0.2  
	const int iSampleFPS = 5;
	TimeValue tIncrement = SecToTicks(1.0f / iSampleFPS);

	// Write out the animations duration
	Write(iTreeDepth, "   TRS Anim Start: %fs, Anim End: %fs", TicksToSec(ivAnimRange.Start()), TicksToSec(ivAnimRange.End()));

	// Sample the node over the range, writing out iSampleFPS samples per second
	for (TimeValue t = ivAnimRange.Start(); t < ivAnimRange.End(); t += tIncrement)
	{
		Write(iTreeDepth + 1, "SampleTime: %fs", TicksToSec(t));
		ExportTRS(pNode, iTreeDepth + 1, t);
	}
}

void maxPluginTest::ExportAnimationKeys(Animatable* pAnim, const char* pCtrlName, int iTreeDepth)
{
	// Write out the name passed in
	Write(iTreeDepth, pCtrlName);

	// Can we export this controller directly?
	IKeyControl* iKeyControl = GetKeyControlInterface(pAnim);
	if (iKeyControl == NULL)
	{
		// No keys on this controller, but maybe it uses sub-controllers
		// to derive its value
		for (int i = 0; i < pAnim->NumSubs(); i++)
		{
			Animatable* pSubCtrl = pAnim->SubAnim(i);
			MSTR sSubName = pAnim->SubAnimName(i);
			ExportAnimationKeys(pSubCtrl, sSubName.data(), iTreeDepth + 1);
		}
	}
	else
	{
		// This is a keyframe controller, we just have no data.
		if (iKeyControl->GetNumKeys() == 0) return;

		// Here we test the class ID to see what type of
		// key frames this controller will hold
		Class_ID clid = pAnim->ClassID();
		switch(clid.PartA())
		{
		case LININTERP_FLOAT_CLASS_ID:
			ExportAnimationKeyLinear<ILinFloatKey>(iKeyControl, iTreeDepth);
			break;
		case LININTERP_POSITION_CLASS_ID:
			ExportAnimationKeyLinear<ILinPoint3Key>(iKeyControl, iTreeDepth);
			break;
		case LININTERP_ROTATION_CLASS_ID:
			ExportAnimationKeyLinear<ILinRotKey>(iKeyControl, iTreeDepth);
			break;
		case LININTERP_SCALE_CLASS_ID:
			ExportAnimationKeyLinear<ILinScaleKey>(iKeyControl, iTreeDepth);
			break;

		case HYBRIDINTERP_FLOAT_CLASS_ID:
			ExportAnimationKeyBezier<IBezFloatKey>(iKeyControl, iTreeDepth);
			break;
		case HYBRIDINTERP_POSITION_CLASS_ID:
			ExportAnimationKeyBezier<IBezPoint3Key>(iKeyControl, iTreeDepth);
			break;
		case HYBRIDINTERP_ROTATION_CLASS_ID:
			// The HYBRIDINTERP rotation class is unique in that it doesn't use
			// bezier interpolation: We export this as a simple linear key
			ExportAnimationKeyLinear<IBezQuatKey>(iKeyControl, iTreeDepth);
			break;
		case HYBRIDINTERP_SCALE_CLASS_ID:
			ExportAnimationKeyBezier<IBezScaleKey>(iKeyControl, iTreeDepth);
			break;

		case TCBINTERP_FLOAT_CLASS_ID:
			ExportAnimationKeyTCB<ITCBFloatKey>(iKeyControl, iTreeDepth);
			break;
		case TCBINTERP_POSITION_CLASS_ID:
			ExportAnimationKeyTCB<ITCBPoint3Key>(iKeyControl, iTreeDepth);
			break;
		case TCBINTERP_ROTATION_CLASS_ID:
			ExportAnimationKeyTCB<ITCBRotKey>(iKeyControl, iTreeDepth);
			break;
		case TCBINTERP_SCALE_CLASS_ID:
			ExportAnimationKeyTCB<ITCBScaleKey>(iKeyControl, iTreeDepth);
			break;

		default:
			// If we hit this, we need to update our exporter to support this controller.
			Write(iTreeDepth, "ERROR: Unknown class exported under KeyFrames: (0x%X, 0x%X)", clid.PartA(), clid.PartB());
			break;
		}
	}
}

template<class KeyType>
void maxPluginTest::ExportAnimationKeyLinear(IKeyControl* iKeyControl, int iTreeDepth)
{
	Write(iTreeDepth, "  Linear Interpolation");
	KeyType ioKey;
	for (int i = 0; i < iKeyControl->GetNumKeys(); i++)
	{
		iKeyControl->GetKey(i, &ioKey);
		Write(iTreeDepth, "Key at time %fs:", TicksToSec(ioKey.time));
		WriteValue(iTreeDepth, "    Value: ", ioKey.val);
	}
}

template<class KeyType>
void maxPluginTest::ExportAnimationKeyBezier(IKeyControl* iKeyControl, int iTreeDepth)
{
	Write(iTreeDepth, "  Bezier Interpolation");
	KeyType ioKey;
	for (int i = 0; i < iKeyControl->GetNumKeys(); i++)
	{
		iKeyControl->GetKey(i, &ioKey);
		Write(iTreeDepth, "Key at time %fs:", TicksToSec(ioKey.time));
		WriteValue(iTreeDepth, "    Value: ", ioKey.val);
		WriteValue(iTreeDepth, "    In Tangent: ", ioKey.intan);
		WriteValue(iTreeDepth, "    Out Tangent: ", ioKey.outtan);
		WriteValue(iTreeDepth, "    in Length: ", ioKey.inLength);
		WriteValue(iTreeDepth, "    Out Length: ", ioKey.outLength);
	}
}

template<class KeyType>
void maxPluginTest::ExportAnimationKeyTCB(IKeyControl* iKeyControl, int iTreeDepth)
{
	Write(iTreeDepth, "  TCB Interpolation");
	KeyType ioKey;
	for (int i = 0; i < iKeyControl->GetNumKeys(); i++)
	{
		iKeyControl->GetKey(i, &ioKey);
		Write(iTreeDepth, "Key at time %fs:", TicksToSec(ioKey.time));
		WriteValue(iTreeDepth, "    Value: ", ioKey.val);
		Write(iTreeDepth, "   tension: %f continuity: %f bias: %f", ioKey.tens, ioKey.cont, ioKey.bias);
		Write(iTreeDepth, "   ease in: %f ease out: %f", ioKey.easeIn, ioKey.easeOut);
	}
}



bool maxPluginTest::BeginWriting(const char *pPath)
{
	// Check we are not currently writing
	DbgAssert(m_pFile == NULL);

	errno_t lErr = fopen_s(&m_pFile, pPath, "w");
	return ( lErr == 0 );
}

void maxPluginTest::EndWriting()
{
	DbgAssert(m_pFile != NULL);

	fclose(m_pFile);
	m_pFile = NULL;
}

void maxPluginTest::Write(int indent, const char* pMsg, ...)
{
	DbgAssert(m_pFile != NULL);

	// first, write in the indent
	for (int i = 0; i < indent; i++) fprintf_s(m_pFile, "\t");

	// Write the message, passing in our variable
	// parameters to a function that wraps printf
	va_list vargs;
	va_start(vargs, pMsg);
	vfprintf_s(m_pFile, pMsg, vargs);
	va_end(vargs);

	// Finish the line
	fprintf_s(m_pFile, "\n");
}


void maxPluginTest::Write(int indent, const Matrix3 &tmVal)
{
	AffineParts apVal;
	decomp_affine(tmVal, &apVal);

	// Write out the position
	WriteValue(indent, "TRS: T ", apVal.t);
	// The Euler rotation
	WriteValue(indent, "     R ", apVal.q);
	// And finally the scale
	WriteValue(indent, "     S ", apVal.k);
}

void maxPluginTest::WriteValue(int indent, const char* pMsg, float val)
{
	Write(indent, "%s%f", pMsg, val);
}

void maxPluginTest::WriteValue(int indent, const char* pMsg, const Point3& val)
{
	Write(indent, "%sPoint3(%f, %f, %f)", pMsg, val.x, val.y, val.z);
}

void maxPluginTest::WriteValue(int indent, const char *pMsg, const Quat &val)
{
	// Convert the rotation quaternion into a rotation Euler
	// this is simply because it is easier for us to read in ASCII
	float dRotEuler[3];
	val.GetEuler(&dRotEuler[0], &dRotEuler[1], &dRotEuler[2]);

	Write(indent, "%sEuler(%f, %f, %f)", pMsg, dRotEuler[0], dRotEuler[1], dRotEuler[2]);
}

void maxPluginTest::WriteValue(int indent, const char* pMsg, const AngAxis& val)
{
	// Keep our rotations consistent, convert to Quat and write that
	Quat q(val);
	WriteValue(indent, pMsg, q);
}

void maxPluginTest::WriteValue(int indent, const char *pMsg, const ScaleValue &val)
{
	Write(indent, "%sScale(%f, %f, %f)", pMsg, val.s.x, val.s.y, val.s.z);
}
